




#ifndef _IDX_H_
#define _IDX_H_


//################################################################################
//###
//###   DataBase handle
//###


#define IDX_DB_TRNS 0x1<< 1	// Transient tables
#define IDX_DB_REFR 0x1<< 2	// Refresh resident tables at each read

typedef struct S_Idx_DB * Idx_DB ;

Idx_DB		_Idx_DBRead(Idx_DB db) ;
Idx_DB		_Idx_DBWrite(Idx_DB db) ;
Idx_DB		Idx_DBCreate(char * file, unsigned long id, unsigned long wlen, unsigned long flen, unsigned long vlen, unsigned long flags) ;
Idx_DB		Idx_DBOpen(char * file, unsigned long flags) ;
void		Idx_DBClose(Idx_DB db) ;
void		Idx_DBStat(Idx_DB db) ;



//################################################################################
//###
//###   Index retrival and querying
//###


typedef struct S_Idx_Index * Idx_Index ;

// Index object management
Idx_Index	Idx_IndexAlloc(Idx_DB db, char * word) ;
void		Idx_IndexFree(Idx_Index idx) ;
void		Idx_IndexStat(Idx_Index idx) ;
void		Idx_IndexPrint(Idx_Index idx) ;

// Index retrival / storage
Idx_Index	_Idx_IndexRead(Idx_DB db, unsigned long pos) ;
Idx_Index	_Idx_IndexWrite(Idx_DB db, Idx_Index idx, unsigned long pos) ;
Idx_Index	Idx_IndexGet(Idx_DB db, char * word) ;
Idx_Index	Idx_IndexAdd(Idx_DB db, char * word) ;
Idx_Index	Idx_IndexSet(Idx_DB db, Idx_Index idx) ;
void		Idx_IndexDel(Idx_DB db, char * word) ;
char *		Idx_IndexWord(Idx_Index idx) ;
double		Idx_IndexEval(Idx_Index idx) ;
unsigned long	Idx_IndexLen(Idx_Index idx) ;

// Index querying
void		Idx_FieldAdd(Idx_Index idx, char * fld, char * val) ;
char *		Idx_FieldGet(Idx_Index idx, char * fld) ;
void		Idx_FieldDel(Idx_Index idx, char * fld) ;
char *		Idx_FieldValByNum(Idx_Index idx, unsigned long num) ;
char *		Idx_FieldFldByNum(Idx_Index idx, unsigned long num) ;



#endif // _IDX_H_


